Package ghidra.util

# Enum Class AddressRangeComparators

java.lang.Object
java.lang.Enum<AddressRangeComparators>
ghidra.util.AddressRangeComparators

All Implemented Interfaces:
  `Serializable`, `Comparable<AddressRangeComparators>`, `Constable`, `Comparator<AddressRange>`

public enum AddressRangeComparators extends Enum<AddressRangeComparators> implements Comparator<AddressRange>
Comparators used for sorting address ranges

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BACKWARD`
  Compare ranges by their maximum address and order them largest first.
  `FORWARD`
  Compare ranges by their minimum address and order them smallest first.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static AddressRangeComparators`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static AddressRangeComparators[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Comparator

  `compare, equals, reversed, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- ## Enum Constant Details

  - ### FORWARD

    public static final AddressRangeComparators FORWARD
    Compare ranges by their minimum address and order them smallest first.

  - ### BACKWARD

    public static final AddressRangeComparators BACKWARD
    Compare ranges by their maximum address and order them largest first.
    Implementation Notes:
      Which address is compared might not ordinarily matter, since `AddressSet` requires a disjoint union of ranges. However, these comparators often compare ranges from different sets, e.g., in order to merge two or more iterators. Thus, in reverse, we want to ensure ranges are ordered by their maximum address.

- ## Method Details

  - ### values

    public static AddressRangeComparators[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static AddressRangeComparators valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null